﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Data;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace XamGridDeleteButtonInCell
{
    public partial class MainWindow : Window
    {
        public static RoutedCommand DeleteCommand = new RoutedCommand();

        public MainWindow()
        {
            InitializeComponent();

            BindingList<Person> persons = new BindingList<Person>();
            persons.Add(new Person("Hans", "Rosenthal"));
            persons.Add(new Person("Robert", "Mayer"));
            persons.Add(new Person("Daniel", "Mayer"));
            persons.Add(new Person("Christian", "Mayer"));
            persons.Add(new Person("Hans", "Bauer"));
            persons.Add(new Person("Kai", "Rosenthal"));
            persons.Add(new Person("Helmut", "Bauer"));
            persons.Add(new Person("Jürgen", "Huber"));
            persons.Add(new Person("Thomas", "Rosenthal"));
            persons.Add(new Person("Julia", "Bauer"));
            persons.Add(new Person("Kerstin", "Huber"));
            this.xamDataGrid1.DataSource = persons;
        }

        private void DeleteCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = true;
            e.Handled = true;
        }

        private void DeleteExecute(object sender, ExecutedRoutedEventArgs e)
        {
            DataRecord dr = this.xamDataGrid1.ActiveRecord as DataRecord;
            if (dr == null) return;

            BindingList<Person> dataSource = this.xamDataGrid1.DataSource as BindingList<Person>;
            if (dataSource == null) return;

            dataSource.Remove(dr.DataItem as Person);
            e.Handled = true;
        }
    }
}
